''************************************
''*  Thre axis stepper demo          *
''*  By Alberto Geraci               *
''*  BTX Sistemas                    *
''************************************
'
'      Use:
'      pulx := Steps quantity X axis.
'      puly := Steps quantity Y axis.
'      pulz := Steps quantity Z axis.
'      mulx := Steps multiplier plus rotation sense X axis.   '   Mulx = 0 means that Zero state machine is requested.
'      muly := Steps multiplier plus rotation sense Y axis.   '   %BBBBBBC0 --- B => multiplier   C => CW=1, CCW=0
'      mulz := Steps multiplier plus rotation sense Z axis.   '
'      Acelleration, deceleration controlled by each by a potenciometer.
'      Speed controlled bya potenciometer too.
'      Improved acceleration lets you to get more toque in motor, and send any quantity of pulses to turn without affect performance.

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  PinX = 4            ' Out pulses pin x axis
  PinY = 6            ' Out pulses pin y axis
  PinZ = 8            ' Out pulses pin z axis
  Acc  = 0            ' Pin for acceleration/deceleration potenciometer
  Vel  = 10           ' Pin for speed potenciometer
   
VAR
byte pulx   
byte puly
byte pulz
byte mulx
byte muly
byte mulz
byte Dirx
byte Diry
byte Dirz
byte Zero     ' Zero machine variable detect.
long RCValue
long RCValor
long TimeR
long Speed
  
OBJ
  Turn[3]     : "PaP"
  serial      : "FullDuplexSerial"
  RC[2]       : "RCTimeB"
  
PUB Main
   serial.start(31,30,%0000,57600)
   serial.rxflush
   'Initialize RCValue
   RCValue := 0
   RCValor := 0
   RC[0].start(Acc,@RCValue ) ' use 22kohm and 0.1 uF
   RC[1].start(Vel,@RCValor ) ' use 22kohm and 0.1 uF
   Girar
   
PRI Girar

   repeat
    pulx := serial.rx
    puly := serial.rx
    pulz := serial.rx
    mulx := serial.rx
    muly := serial.rx
    mulz := serial.rx
     
    TimeR := RCValue /= 100
    TimeR := TimeR * 100
    Speed := RCValor /= 100
    Speed := Speed * 1000

    if mulx & %00000010 
      Dirx := 1
    else
      Dirx := 0
      mulx >>= 2
          
    if muly & %00000010 
       Diry := 1
    else
       Diry := 0
       muly >>= 2
          
    if mulz & %00000010
       Dirx := 1
    else
       Dirx := 0
       mulz >>= 2
     
    Ifnot mulx 
       Zero := 1
    else   
       Zero := 0
     
    Turn[0].Start(PinX,Dirx,Zero,Speed,TimeR,pulx*mulx)
    Turn[1].Start(PinY,Diry,Zero,Speed,TimeR,puly*muly)
    Turn[2].Start(PinZ,Dirz,Zero,Speed,TimeR,pulz*mulz)
       
   